char *str = "Hallo Welt";
char result[] = "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0";
/* char *result = 0x4000; */

int get_pangram(char *s){
  int r = 0x3ffffff;
  int i;
  char c;
  for(i = 0; *s; s++, i++){
    c = *s;
    c &= ~0x20;                  /* Uppercase */
    c |= 0x40;                   /* Ensure A-Z */
    c -= 0x41;
    r ^= 1 << c;
  }
  return r;
}

void print_missing_letters(int pangram, char *dest){
  int i;
  int j;
  /* pangram = ~pangram; */
  for(j = 'A', i = 1; pangram; i <<= 1, j++){
    if (pangram & i){
      pangram ^= i;
      *dest = j | 0xf500;       /* Whee. Compiles nice on x86 and
                                   hicovec. On x86 the f5 is cut as
                                   the write is only a byte wide. */
      dest++;
    }
  }
  *dest = 0;
}


int main(void){
  print_missing_letters(get_pangram(str), result);
  return 0;
}
