; ##### test_vectorunit.asm ############################
; Vergleich zwischen skalarer Einheit und Vektoreinheit
; siehe: test_scalarunit.asm 
; ######################################################

.org 0x00
.start

OR A, 0, VEC0 	;Adr. vek1 in A laden
OR X, 0, VEC1 	;Adr. vek2 in Y laden
OR Y, 0, RESULT 		;Adr. erg in Y laden
VLD R0, [0 + A]	;vek1 in R0 laden
VLD R1, [0 + X]	;vek2 in R1 laden
VADD.W R2, R0, R1	;R0 + R1 in R2 mit 16bit Breite
VST [0 + Y], R2	;R2 in erg speichern

HALT

	; insgesamt 7 Befehle - Skalareinheit: 112 Befehle!

.org 0xff
VEC0:
	.dc 1
	.dc 2
	.dc 3
	.dc 4
	.dc 5
	.dc 6
	.dc 7
	.dc 8
	.dc 9
	.dc 10
	.dc 11
	.dc 12
	.dc 13
	.dc 14
	.dc 15
	.dc 16

VEC1:
	.dc 16
	.dc 15
	.dc 14
	.dc 13
	.dc 12
	.dc 11
	.dc 10
	.dc 9
	.dc 8
	.dc 7
	.dc 6
	.dc 5
	.dc 4
	.dc 3
	.dc 2
	.dc 1
	

.org 0xfff
RESULT:
	.dc 0

.end
