#include "commit.h"
#include "functions.h"
#include "parseFunctions.c"
#include "writeInFile.c"
#include <stdio.h>



int main()
{
	FILE *fp;
	COMMAND_RETURN dummy;
	COMMAND_RETURN cmdRet1;
	COMMAND_RETURN cmdRet2;

	fp = fopen("testfile.txt","w");

/*	TEST der neuen ParseFunctions
	printf("Zum Vergleich: \"hexdump testfile.txt\" aufrufen!!!\n\n\n");


	//! Test der Funktion für Skalareinheit ohne Direktwert
	printf("1. ScalarAndReg\t\tLD A,X,Y\tErwartet: 0x81b00000\n");
	dummy=NewCommand_ScalarAndReg(1,  0x20, 1, 2, 3, NULL, 1, 0);
	fwriteIntBigEndian(dummy.code, &fp);

	//! Test der Funktion für Vektoreinheit ohne Direktwert
	printf("2. VectorAndReg\t\tVMOV R1,R2\tErwartet: 0x00021120\n");
	dummy=NewCommand_VectorAndReg(1,  0x21, 1, 2, 0, NULL, 1, 0);
	fwriteIntBigEndian(dummy.code, &fp);

	//! Test der Funktion für Vektoreinheit mit Direktwert(als Registerindex)
	printf("3. VeRegDirect\t\tVMOV R1,R(32)\tErwartet: 0x02022100\n");
	dummy=NewCommand_VectorRegDirectValue(1,  0x22, 1, 0, 32, NULL, 1, 0);
	fwriteIntBigEndian(dummy.code, &fp);

	//! Test der Funktion für Skalareinheit mit Direktwert
	printf("4. ScRegDirect\t\tADD R1,R2,1024\tErwartet: 0x41800400\n");
	dummy=NewCommand_ScalarRegDirectValue(1,  0x10, 1, 2, 1024, NULL, 1, 0);
	fwriteIntBigEndian(dummy.code, &fp);

	//! Test der Funktion für Movebefehle
	printf("5. MoveCmd\t\tMOVE R0(A),X)\tErwartet: 0xb8684000\n");
	dummy=NewCommand_MoveCmds(1,  0x2e, 0, 1, 2,0x84,0,0, NULL, 1, 0);
	fwriteIntBigEndian(dummy.code, &fp);

	//! Test der Funktion für die Vektoralubefehle
	printf("6. VectorAlu\t\tVADD.B R0,R1,R2\tErwartet: 0x00040012\n");
	dummy=NewCommand_VectorAlu(1,  0, 0, 0, 1,2, NULL, 1, 0);
	fwriteIntBigEndian(dummy.code, &fp);

	//! Test der Funktion für die Vektoralubefehle
	printf("6. Shuffle\t\tVSHUF.B R0,R1,R2,10000000\tErwartet: 0x040c0123\n");
	dummy=NewCommand_shuffle(1,  0, 0, 0, 1,2,128, NULL, 1, 0);
	fwriteIntBigEndian(dummy.code, &fp);
*/


// TEST der uniteCommands-Funktion

	printf("1. ScalarAndReg\t\tLD A,X,Y\tErwartet: 0x81b00000\n");
	cmdRet1=NewCommand_ScalarAndReg(1,  0x20, 1, 2, 3, NULL, 1, 0);

	printf("2. VectorAndReg\t\tVMOV R1,R2\tErwartet: 0x00021120\n");
	cmdRet2=NewCommand_VectorAndReg(1,  0x21, 1, 2, 0, NULL, 1, 0);


//********************SYNTAXPRÜFUNG**************************/
	// Andere Möglichkeiten sind nicht möglich, da diese von einer Syntaxprüfung abgefangen werden müssen
	if (cmdRet1.isSkalar == 1 && cmdRet2.isVektor == 1) // Abfrage: Ist cmdRet1 ein Skalarbefehl?
		dummy = uniteCommands(&cmdRet1,&cmdRet2);
	else if (cmdRet1.isVektor == 1 && cmdRet2.isSkalar == 1) // Abfrage: Ist cmdRet ein Vektorbefehl?
		dummy = uniteCommands(&cmdRet2,&cmdRet1);
	else printf("\nregeln falsch?!?!\n");
	fwriteInt32Bit(dummy.code, &fp);

	fclose(fp);


	return 0;
}
