package hicosim.components.frontend.tablemodels;

import java.util.Vector;

import javax.swing.table.DefaultTableModel;

public class CustomDefaultTableModelScalarCpuRegisterOverview extends
		DefaultTableModel {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	/**
	 *
	 */
	public CustomDefaultTableModelScalarCpuRegisterOverview() {
		super();
	}

	/**
	 * @param int rowCount
	 * @param int columnCount
	 */
	public CustomDefaultTableModelScalarCpuRegisterOverview(int rowCount,
			int columnCount) {
		super(rowCount, columnCount);
	}

	/**
	 * @param Object[] columnNames
	 * @param int rowCount
	 */
	public CustomDefaultTableModelScalarCpuRegisterOverview(
			Object[] columnNames, int rowCount) {
		super(columnNames, rowCount);
	}

	/**
	 * @param Object[][] data
	 * @param Object[] columnNames
	 */
	public CustomDefaultTableModelScalarCpuRegisterOverview(Object[][] data,
			Object[] columnNames) {
		super(data, columnNames);
	}

	/**
	 * @param Vector columnNames
	 * @param int rowCount
	 */
	@SuppressWarnings("unchecked")
	public CustomDefaultTableModelScalarCpuRegisterOverview(Vector columnNames,
			int rowCount) {
		super(columnNames, rowCount);
	}

	/**
	 * @param Vector data
	 * @param Vector columnNames
	 */
	@SuppressWarnings("unchecked")
	public CustomDefaultTableModelScalarCpuRegisterOverview(Vector data,
			Vector columnNames) {
		super(data, columnNames);
	}

	/**
	 * This method checks if the passed cell, specified by the two
	 * Integer-Objects "rowIndex" and "columnIndex", is editable. It must be
	 * overwritten in order to guarantee user inputs via mouse and keyboard.
	 *
	 * @author Daniel Obermueller 18th June 2009
	 * @param int
	 *            rowIndex
	 * @param int
	 *            columnIndex
	 * @return boolean
	 */
	public boolean isCellEditable(int rowIndex, int columnIndex) {
		/*
		 * If the row "rowIndex" and column "columnIndex" are within the bounds
		 * of the JTable and are not 0 (0 would be a column or row identifier
		 * and therefore must not be edited), the cell is editable.
		 */
		if (rowIndex > 0 && rowIndex < super.getRowCount() && columnIndex > 0
				&& columnIndex < super.getColumnCount())
			return true;
		return false;
	}
}
