/*Uebersetzer fuer Prozessor*/

%{
	#include <stdio.h>
	#include <string.h>
	#include <stdlib.h>

	int yyerror(char *msg);
	int yydebug = 1;
	extern int yydebug;			
%}

%union
{
	int i;
}

%token REGISTER
%token <i> ZAHL
%token <i> REGAXY VREGL BYTE WORD DOUBLEWORD QUADWORD
%type <i> breitebw breitevoll


%start main

%%
main: 	programm main
	| programm
;

programm:

	
|
	REGAXY {printf("REGAXY regaxy0:\tWurde korrekt erkannt\t");
		printf("1. %i\t",$1);
		}
| 	VREGL  {printf("VREGL VREGH:\tWurde korrekt erkannt\t");
		printf("1. %i\t",$1);
		}
| 	breitebw breitevoll {printf("VREGL VREGH:\tWurde korrekt erkannt\t");
		printf("1. %i\t2. %i\n",$1,$2);
		} 
|	REGISTER
;



breitebw:	BYTE   {$$=$1;}
		| WORD {$$=$1;} 	
;
breitevoll:	BYTE   {$$=$1;}
		| WORD {$$=$1;} 
		| DOUBLEWORD {$$=$1;} 
		| QUADWORD {$$=$1;} 	
;
%%
#include "flexer.c"

int yyerror(char *msg)
{
	printf("%s", msg);

}

int main(int argc, char **argv)
{
	yydebug = 1;
	//call of the Parser
	yyparse();
	

	//say that the Compiler worked without an error
	return 0;
}
