;SCOTCH-RACE v1.0 
;Key-Version
;(c) 2009 Andreas Mueller, Hochschule Augsburg

; Leere Strasse mit roten Curps passend für 16 Vektoreinheiten in VGA-RAM auf Zeile 201 Laden:
	.org 0x3f40
	;.org 0x2000
STRROT:	.dc 0x66666666	
	.dc 0x77666666
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x66666677
	.dc 0x66666666
; Leere Strasse mit weissen Curps passend für 16 Vektoreinheiten in VGA-RAM auf Zeile 201+16 Laden:
	.org 0x3f50
	;.org 0x2028
STRWEI:	.dc 0x00000000	
	.dc 0x77000000
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x77777777
	.dc 0x00000077
	.dc 0x00000000
;rotes Auto an Adresse 0x400
	.org 0x400
AUTO:	.dc 0x66666666
	.dc 0xFF7667FF
	.dc 0xFF7667FF
	.dc 0x77666677
	.dc 0xFF6666FF
	.dc 0xFF6666FF
	.dc 0x76666667
	.dc 0x76666667
	.dc 0x77777777
;Variablen:
POINTCNT: .dc 0x0
LIFECNT:  .dc 0x5
STEPS:	  .dc 0x4
KLEECNT:  .dc 0		;Alle 24 Zeilen ein Kleeblatt
BOMBCNT:  .dc 32	;Alle 16 Zeilen eine Bombe
BOMBCMP:  .dc 0x77FFF777	;Vergleich mit mittlerer Bombenzeile
KLEECMP:  .dc 0x77777577	;Vergleich mit 1. Kleezeile

; Grüner Hintergrund aus 16 Zeichen grün/grün in VGA-RAM auf Zeile 201+32
	.org 0x3f60
;           "0123456789ABCDEF
BACKGR:	.dc "t    t    t      " (0xD,0x5)

TITLE1:	.dc "SCOTCH           " (0xf,0x5)
TITLE2:	.dc "RACE..           " (0x6,0x5)
POINTS:	.dc " PUNKTE:         " (0xf,0x5)
LIVES:	.dc "LEBEN:           " (0x6,0x5)
WON:	.dc "  GLUECKWUNSCH   " (0x0,0x6)
LOST:	.dc "  GAME OVER...   " (0x0,0x6)
BEGIN:	.dc "DRUECKE START    " (0x0,0x6)


;Programmstart
	.org 0x0
	.start
START:	OR X, 0, BACKGR		;Adresse von Hintergrund in X laden
	VLD R10, [0 + X]	;Hintergrund in R10 laden

	OR X, 0, STRWEI		;Adresse von Straße weiß in X laden
	VLD R8, [0 + X]		;Straße weiß in R8 laden

	OR X, 0, STRROT		;Adresse von Hintergrund in X laden
	VLD R9, [0 + X]		;Straße rot in R9 laden	

	OR Y, 0, 0x3F		;Schleife 63x durchlaufen
	OR X, 0, 0x43E0		;Adresse der letzten ASCII Zeile laden
BACKDR:	VST [0 + X], R10	;Bildschirm mit Hintergrund füllen
	SUB X, X, 0x10
	SUB Y, Y, 0x1
	JNZ [0 + BACKDR]

	OR X, 0, TITLE1		;Adresse von Titel 1
	VLD R10, [0 + X]
	OR X, 0, 0x4370
	VST [0 + X], R10	;Titel 1 schreiben

	OR X, 0, TITLE2		;Adresse von Titel 1
	VLD R10, [0 + X]
	OR X, 0, 0x4398
	VST [0 + X], R10	;Titel 1 schreiben
;Warten auf drücken des Startknopfes
	OR A, 0, BEGIN		;Adresse von Titel 1
	VLD R10, [0 + A]
	OR A, 0, 0x4174
	VST [0 + A], R10	;Titel 1 schreiben
START0: LD A, [0 + 0xFFFF]	;Taster laden
	AND A, A, 0x0400	;Button maskieren
	SUB 0, A, 0x0400	;auf CENTER Taster prüfen
	JNZ [0 + START0]
; Beginn mit Straßenaufbau
	OR X, 0, 0x214C		;Adresse der 9.  Zeile + Offseet laden
	OR Y, 0, 12		;Schleife 10x durchlaufen
STRDR:	OR A, 0, 8		;nach 10 Zeilen Farbe wechseln	
STRRDR:	VST [0 + X], R9		;Straße mit roten Curps in VGA RAM
	ADD X, X, 0x28
	SUB A, A, 1
	JNZ [0 + STRRDR]
	OR A, 0, 8		;nach 10 Zeilen Farbe wechseln	
STRWDR:	VST [0 + X], R8		;Straße mit weissen Curps in VGA RAM
	ADD X, X, 0x28
	SUB A, A, 1
	JNZ [0 + STRWDR]
	SUB Y, Y, 1
 	JNZ [0 + STRDR]
	OR X, 0, 0x14		;Auto auf Straßenmitte
;Testweise Bombe und Kleeblatt setzen
	OR A, 0, 0x756B
	ST [0 + 0x4060],A 
	OR A, 0, 0x7F62		;Bombe zeichnen
	ST [0 + 0x41A2],A 
;Sraße durchshiften
SHIFT:	
	LD A, [0 + 0xFFFF]		;Taster laden
	AND A, A, 0x00F0	;Buttons maskieren
	SUB 0, A, 0x10		;auf WEST Taster prüfen
	JNZ [0 + NoLeft]

;Auto verlangsamen...
	LD A, [0 + STEPS]	;5x Taster bis Schritt...
	SUB A, A, 1
	ST [0 + STEPS], A	;Zähler rücksichern
	LD A, [0 + STEPS]	;5x Taster bis Schritt...
	JNZ [0 + NoLeft]	

	OR A, 0, 0x5		;Zähler auf 5
	ST [0 + STEPS], A	;Zähler rücksichern
	nop
	SUB X, X, 1
	SUB 0, X, 13		;Pruefen ob linker rand erreicht
	JNZ [0 + NoLeft]
	OR X, 0, 14
	
NoLeft:	
	LD A, [0 + 0xFFFF]	;Taster laden
	AND A, A, 0x00F0	;Buttons maskieren
	SUB 0, A, 0x80		;auf EAST Taster prüfen
	JNZ [0 + NoRigh]
;Auto verlangsamen...
	LD A, [0 + STEPS]	;5x Taster bis Schritt...
	SUB A, A, 1
	ST [0 + STEPS], A	;Zähler rücksichern
	LD A, [0 + STEPS]	;5x Taster bis Schritt...
	JNZ [0 + NoRigh]	

	OR A, 0, 0x5		;Zähler auf 5
	ST [0 + STEPS], A	;Zähler rücksichern
	nop
	ADD X, X, 1
	SUB 0, X, 26		;Pruefen ob rechter rand erreicht
	JNZ [0 + NoRigh]
	OR X, 0, 25
NoRigh:
;Bombe legen:
	LD A, [0 + BOMBCNT]	;Zähler...
	SUB A, A, 1
	ST [0 + BOMBCNT], A	;Zähler rücksichern
	LD A, [0 + BOMBCNT]	;5x Taster bis Schritt...
	JNZ [0 + NoBomb]	

	OR A, 0, 64		;Zähler auf 16
	ST [0 + BOMBCNT], A	;Zähler rücksichern
	nop
	OR A, 0, 0x7F62		;Bombe zeichnen
	ST [X + 0x4028],A 
	nop
NoBomb:
;Kleeblatt legen:
	LD A, [0 + KLEECNT]	;Zähler...
	SUB A, A, 1
	ST [0 + KLEECNT], A	;Zähler rücksichern
	LD A, [0 + KLEECNT]	;5x Taster bis Schritt...
	JNZ [0 + NoKlee]	

	OR A, 0, 128		;Zähler auf 128
	ST [0 + KLEECNT], A	;Zähler rücksichern
	nop
	OR A, 0, 0x756B		;Kleeblatt zeichnen
	ST [X + 0x4028],A 
	nop
NoKlee:
	OR A, 0, 0x3F24		;Adresse der letzten Zeile der Straße
	VLD R2, [0 + A]		;Letzte Zeile sichern
	OR Y, 0, 191		;192x pro Bildschirm
SHIFDO:	SUB A, A, 0x28		;Springe in nächste. Zeile
	VLD R3, [0 + A]		;Lade nächste. Zeile
	ADD A, A, 0x28		;Springe zurück
	VST [0 + A], R3		;Überschreibe vorherige Zeile
	SUB A, A, 0x28		;Springe in nächste. Zeile
	SUB Y, Y, 1		;Schleifenzähler
	JNZ [0 + SHIFDO]
	VST [0 + A], R2		; erste Zeile Rücksichern
;Warteschleife
	OR A, 0, 5000
WAIT1:	SUB A, A, 1
	JNZ [0 + WAIT1]

	OR A, 0, 0x7700
	ST [0 + 0x43CE], A	;Autozeile grau überzeichnen
	ST [0 + 0x43CF], A	;Autozeile grau überzeichnen
	ST [0 + 0x43D0], A	;Autozeile grau überzeichnen
	ST [0 + 0x43D1], A	;Autozeile grau überzeichnen
	ST [0 + 0x43D2], A	;Autozeile grau überzeichnen
	ST [0 + 0x43D3], A	;Autozeile grau überzeichnen
	ST [0 + 0x43D4], A	;Autozeile grau überzeichnen
	ST [0 + 0x43D5], A	;Autozeile grau überzeichnen
	ST [0 + 0x43D6], A	;Autozeile grau überzeichnen
	ST [0 + 0x43D7], A	;Autozeile grau überzeichnen
	ST [0 + 0x43D8], A	;Autozeile grau überzeichnen
	ST [0 + 0x43D9], A	;Autozeile grau überzeichnen
;Auto auf Strecke zeichnen (Zeile 192-200)
	LD A, [0 + 0x400]
	ST [X + 0x3DB0], A
	LD A, [0 + 0x401]
	ST [X + 0x3DD8], A
	LD A, [0 + 0x402]
	ST [X + 0x3E00], A
	LD A, [0 + 0x403]
	ST [X + 0x3E28], A
	LD A, [0 + 0x404]
	ST [X + 0x3E50], A
	LD A, [0 + 0x405]
	ST [X + 0x3E78], A
	LD A, [0 + 0x406]
	ST [X + 0x3EA0], A
	LD A, [0 + 0x407]
	ST [X + 0x3EC8], A
	LD A, [0 + 0x408]
	ST [X + 0x3EF0], A
	LD A, [0 + 0x408]
;Suchen nach Kleeberuehrung
	LD A, [X + 0x3D88]	;Eine Zeile genau über Auto
	LD Y, [0 + KLEECMP]	;Lade Vergleichszeile
	SUB 0, A, Y		;Vergleiche
	JNZ [0 + NoKleeCmp]
	LD A,[0 + POINTCNT]	;Punktezähler in A
	ADD A, A, 1		;Addiere Punkt
	ST [0 + POINTCNT], A	;Punkte Rückschreiben
	nop
NoKleeCmp:
;Suchen nach Bombenberuehrung
	LD A, [X + 0x3D88]	;Eine Zeile genau über Auto
	LD Y, [0 + BOMBCMP]	;Lade Vergleichszeile
	SUB 0, A, Y		;Vergleiche
	JNZ [0 + NoBombCmp]
	LD A,[0 + LIFECNT]	;Lebenszähler in A
	SUB A, A, 1		;Subtrahiere Leben
	ST [0 + LIFECNT], A	;Leben Rückschreiben
	nop
NoBombCmp:
; Titel und Punkte Schreiben
	OR A, 0, POINTS		;Adresse von Punkte
	VLD R10, [0 + A]
	OR A, 0, 0x4000
	VST [0 + A], R10	;Points schreiben

	OR A, 0, TITLE1		;Adresse von Titel 1
	VLD R10, [0 + A]
	OR A, 0, 0x400E
	VST [0 + A], R10	;Titel 1 schreiben

	OR A, 0, TITLE2		;Adresse von Titel 1
	VLD R10, [0 + A]
	OR A, 0, 0x4015
	VST [0 + A], R10	;Titel 1 schreiben

	OR A, 0, LIVES		;Adresse von Titel 1
	VLD R10, [0 + A]
	OR A, 0, 0x401F
	VST [0 + A], R10	;Titel 1 schreiben

	LD A,[0 + POINTCNT]	;Punktezähler in A
	SUB 0, A, 10
	JZ [0 + Winner]		;Wenn 10 Punkte dann Gewonnen
	ADD A, A, 0x5F30	;Aus Zahl ASCII erstellen
	ST [0 + 0x4009], A	;Punte schreiben

	LD A,[0 + LIFECNT]	;Lebenszähler in A
	JZ [0 + Looser]		;Wenn 0 Leben dann Verloren
	ADD A, A, 0x5630	;Aus Zahl ASCII erstellen
	ST [0 + 0x4026], A	;Leben schreiben

	
	JMP [0 + SHIFT]		;Dauerschleife	

Winner:	OR A, 0, WON		;Adresse von Titel 1
	VLD R10, [0 + A]
	OR A, 0, 0x4174
	VST [0 + A], R10	;Titel 1 schreiben
RESTART1: LD A, [0 + 0xFFFF]	;Taster laden
	AND A, A, 0x0400	;Button maskieren
	SUB 0, A, 0x0400	;auf CENTER Taster prüfen
	JNZ [0 + RESTART1]
	OR A, 0, 0		;Addiere Punkt
	ST [0 + POINTCNT], A	;Punkte Rücksetzen
	nop
	OR A, 0, 5		;Addiere Punkt
	ST [0 + LIFECNT], A	;Leben Rücksetzen
	nop	
	JMP [0 + START]
Looser: 
	OR A, 0, LOST		;Adresse von Titel 1
	VLD R10, [0 + A]
	OR A, 0, 0x4174
	VST [0 + A], R10	;Titel 1 schreiben
RESTART2: LD A, [0 + 0xFFFF]	;Taster laden
	AND A, A, 0x0400	;Button maskieren
	SUB 0, A, 0x0400	;auf CENTER Taster prüfen
	JNZ [0 + RESTART2]
	OR A, 0, 0		;Addiere Punkt
	ST [0 + POINTCNT], A	;Punkte Rücksetzen
	nop
	OR A, 0, 5		;Addiere Punkt
	ST [0 + LIFECNT], A	;Leben Rücksetzen
	nop	
	JMP [0 + START]
ENDE:	HALT
	.end